<template>
  <div id="class_notice_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <el-breadcrumb-item :to="{ path: `/a/${authType ? 'teacher' : 'student'}/NNclass/${classId}` }">{{ className }}</el-breadcrumb-item>
      <el-breadcrumb-item :to="{ path: `/a/class/${classId}/NNNotice/0` }">{{ $t('CLASS_MENU.NOTICE') }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ noticeName }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <router-link :to="{ path: `/a/class/${classId}/NNNotice/0` }">
          <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
        </router-link>
      </div> 
    </el-breadcrumb>
    <h1> {{ noticeName }} </h1>
    <hr>

    <editor-content :editor="editor" :style="`height: ${height}; overflow-y: scroll; margin-bottom: 20px;`"/>

    <el-button v-if="isNoticeOwner" @click="onClick('DELETEPOST')" type="danger" plain style="float: right;margin-top: 40px; margin-bottom: 40px;">{{ $t('LECTURE_LIST.DELETE') }}</el-button>
    <el-button v-if="isNoticeOwner" @click="onClick('MODIFY')" plain style="float: right;margin-top: 40px; margin-bottom: 40px;">{{ $t('LECTURE_LIST.EDIT') }}</el-button>
    <p></p>
    <p></p>
    <div v-if="files.length > 0">
      <hr>
      <h4>{{ $t('BOARD.ATTACH_FILE') }}</h4>
      <div :key="file.file_guid" v-for="file in files" style="margin: 20px 0px 20px 10px;">
        <span>{{ $t('MATERIAL.NAME') }} : {{ file.name }} </span>
        <el-button @click="onClick('DOWNLOAD',file.client_path,file.name)">{{ $t('DOWNLOAD.DOWN') }}</el-button>
      </div>
    </div>
    <hr>
    <div style="width: 100%">
      <el-input v-model="comment" :placeholder="$t('BOARD.ENTER_COMM')">
        <el-button slot="append" @click="onClick('SAVECOMMENT')" type="text" style="width: 100px">{{ $t('BOARD.SAVE_COMM') }}</el-button>
      </el-input>
    </div>
    <div :key="reply.notice_reply_id" v-for="reply in notice_replies" style="margin: 20px 0px 20px 10px;">
      <span>{{ reply.user.name }}  :  {{ reply.content }}</span>
      <el-button v-if="reply.user_id === jwtUserId" @click="onClick('DELETECOMMENT', reply.notice_reply_id)" type="danger" size="small" plain>X</el-button>
      <hr>
    </div>
  </div>
</template>

<script>
import { Editor, EditorContent } from 'tiptap';
import {
  Blockquote,
  CodeBlock,
  HardBreak,
  Heading,
  OrderedList,
  BulletList,
  ListItem,
  TodoItem,
  TodoList,
  Bold,
  Code,
  Italic,
  Link,
  Strike,
  Underline,
  History,
} from 'tiptap-extensions';
import utils from '../../utils';
import { baseUrl } from '../../services/config';
import classService from '../../services/classService';

export default {
  async created() {
    const vm = this;
    await vm.onCreated();
  },
  components: {
    EditorContent,
  },
  computed: {
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    noticeId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.noticeId, 10);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
    isNoticeOwner() {
      const vm = this;

      return vm.noticeOwner === vm.jwtUserId;
    }
  },
  methods: {
    async onCreated() {
      const vm = this;
      // notice 데이터 가져오기
      const noticeData = (await classService.getNotice({
        classId: vm.classId,
        noticeId: vm.noticeId,
      })).data;

      vm.className = noticeData.class.name;
      vm.noticeName = noticeData.name;
      vm.files = noticeData.files;
      vm.notice_replies = noticeData.notice_replies;
      vm.editor.setContent(noticeData.content);
      vm.noticeOwner = noticeData.user_id;
      // // 공지사항 파일 내용 입력하기
      vm.jwtUserId = utils.getUserIdFromJwt();
      vm.height = `${(window.innerHeight || document.body.clientHeight) * 0.35}px`;
    },
    async onClick(type, arg, arg2) {
      const vm = this;
      switch (type) {
        case 'SAVECOMMENT': {
          await classService.postNoticeComment({
            classId: vm.classId,
            noticeId: vm.noticeId,
            comment: vm.comment,
          });
          vm.comment = '';
          await vm.onCreated();
          break;
        }
        case 'CANCEL': {
          await vm.$router.go(-1);
          break;
        }
        case 'MODIFY': {
          await vm.$router.push(`/a/class/${vm.classId}/NNClassNoticeModify/${vm.noticeId}`);
          break;
        }
        case 'DELETEPOST': {
          // 삭제 확인 메시지
          vm.$confirm(vm.$t('NOTICE.DEL_CHECK'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              // 공지사항 삭제 부분
              const { success } = (await classService.deleteNotice({
                
                noticeId: vm.noticeId,
              })).data;
              if (!success) {
                throw 'internal server error';
              } else {
                vm.$router.push(`/a/class/${vm.classId}/NNNotice/0`);
              }
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTICE.DEL_POST_FAIL'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }
          })
          .catch((error) => {
            vm.$notify({
              title: vm.$t('NOTICE.DEL_POST_FAIL'),
              message: vm.$t('NOTICE.DEL_POST_CANCEL'),
              type: 'success',
              duration: 5000,
            })
          });
          break;
        }
        case 'DELETECOMMENT': {
          // 댓글 삭제 기능
          await classService.deleteNoticeReply({
            noticeReplyId: arg,
          });
          await vm.onCreated();
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
        case 'DOWNLOAD': {
          utils.downloadFile(baseUrl, {
            client_path: arg,
            name: arg2
          });
          break;
        }
      }
    },
  },
  data() {
    return {
      content: '',
      comment: '',
      className: '',
      noticeName: '',
      notice_replies: [],
      files: [],
      fileGuid: 'mock',
      jwtUserId: '',
      noticeOwner: -1,
      editor: new Editor({
        extensions: [
          new Blockquote(),
          new CodeBlock(),
          new HardBreak(),
          new Heading({ levels: [1, 2, 3] }),
          new BulletList(),
          new OrderedList(),
          new ListItem(),
          new TodoItem(),
          new TodoList(),
          new Bold(),
          new Code(),
          new Italic(),
          new Link(),
          new Strike(),
          new Underline(),
          new History(),
        ],
        editable: false,
      }),
      height: '0',
    };
  },
};
</script>